public class Buffer {

	private int N; // Puffergroesse
	private int i; // Anzahl Elemente im Puffer
	private Object[] buf;
	private int in = 0; // naechste freie Position
	private int out = 0; // Index d. abzugebenden Elements

	public Buffer(int N) {
		this.N = N;
		this.i = 0;
		this.buf = new Object[this.N]; // Feld der Groesse N
	}

	public synchronized void put(Object obj) throws InterruptedException {
		System.out.println("put " + obj + " called.");
		while (this.i >= this.N) {
			this.wait();
		}

		this.buf[this.in] = obj;
		this.in = (this.in + 1) % this.N;
		this.i++;
		this.printStatus("put " + obj);

		this.notify();
		System.out.println("put " + obj + " finished.");
	}

	public synchronized Object get() throws InterruptedException {

		System.out.println("get called.");
		while (this.i <= 0) {
			this.wait();
		}

		Object obj = this.buf[this.out];
		this.buf[this.out] = "_"; // nicht noetig
		this.out = (this.out + 1) % this.N;
		this.i--;
		this.printStatus("get  ");

		this.notify();
		System.out.println("get " + obj + " finished.");

		return obj;
	}

	private void printStatus(String s) {
		String output = "  " + s + " changed buffer to [";
		for (int i = 0; i < this.N; i++) {
			output += ((this.buf[i] == null) ? "_" : this.buf[i]);
			output += ((i < (this.N - 1)) ? "," : "]");
		}
		System.out.println(output);
	}
}
